#! /bin/bash

typeset -i TOLERANCE=10
typeset -i DIFF=0

# Make the benchmark program first
if [ ! -e dhrystone ]; then
	make dhrystone
fi

# Aux function
function abs {
	if (( $1 >= $2 )); then
		DIFF=$1-$2
	else
		DIFF=$2-$1
	fi
}

if [ $1 == 'benchmark' ]; then
	./dhrystone > hw_perf.txt
fi

if [ $1 == 'test_noise' ]; then
	typeset -i refperf=$(cat hw_perf.txt)
	typeset -i currperf=$(./dhrystone)
	abs $refperf $currperf
	echo $DIFF $TOLERANCE
	if [ $DIFF -lt $TOLERANCE ]; then
		echo "Machine is quiet"
	else
		echo "Machine is noisy"
		echo "Reference value" $refperf
		echo "Measured value" $currperf
	fi
fi
